"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.addBaseFactoryAbility = exports.BaseFactoryCoreMethods = void 0;
var _inheritsEx = require("inherits-ex");
var _customAbility = require("custom-ability");
var _baseFactory = require("./base-factory.js");
const BaseFactoryCoreMethods = exports.BaseFactoryCoreMethods = ['@_register', '@Factory', '@formatName', '@formatNameFromClass', '@getRealName'];
function getFactoryClass(targetClass, options) {
  class Factory {
    /* istanbul ignore next */
    constructor() {
      this.initialize.apply(this, arguments);
    }
  }
  (0, _inheritsEx.cloneCtor)(Factory, _baseFactory.BaseFactory);
  delete Factory['_findRootFactory'];
  delete Factory['findRootFactory'];
  Factory['_children'] = undefined;
  Factory['_aliases'] = undefined;
  (0, _inheritsEx.defineProperty)(Factory, '_Factory', targetClass);
  return Factory;
}
const addBaseFactoryAbility = exports.addBaseFactoryAbility = (0, _customAbility.createAbilityInjector)(getFactoryClass, BaseFactoryCoreMethods, true);
var _default = exports.default = addBaseFactoryAbility;