"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.addFactoryAbility = exports.CustomFactoryCoreMethods = void 0;
var _customAbility = require("custom-ability");
var _inheritsEx = require("inherits-ex");
var _baseFactory = require("./base-factory.js");
var _customFactory = require("./custom-factory.js");
var _baseFactoryAbility = require("./base-factory-ability.js");
const CustomFactoryCoreMethods = exports.CustomFactoryCoreMethods = [..._baseFactoryAbility.BaseFactoryCoreMethods, '@getClassNameList', '@_registerWithParent'];
function getFactoryClass(targetClass, options) {
  class Factory {
    /* istanbul ignore next */
    constructor() {
      this.initialize.apply(this, arguments);
    }
  }
  (0, _inheritsEx.cloneCtor)(Factory, _baseFactory.BaseFactory);
  (0, _inheritsEx.cloneCtor)(Factory, _customFactory.CustomFactory);
  delete Factory['_findRootFactory'];
  delete Factory['findRootFactory'];
  Factory['_children'] = undefined;
  Factory['_aliases'] = undefined;
  (0, _inheritsEx.defineProperty)(Factory, '_Factory', targetClass);
  return Factory;
}
const addFactoryAbility = exports.addFactoryAbility = (0, _customAbility.createAbilityInjector)(getFactoryClass, CustomFactoryCoreMethods, true);
var _default = exports.default = addFactoryAbility;